export declare var T: any;
export declare class BinaryReader {
    constructor(schemas: any, buffer: Uint8Array);
    strictMode: boolean;
    buffer: Uint8Array;
    dataView: DataView;
    idx: number;
    schemas: any;
    decode(schema: any, buffer: number[]): any;
    readByte(): number;
    typeOf(value: any): any;
    read32le(): number;
    readCount(): number;
    readBoolean(): boolean;
    readInt(): number;
    readLong(): number;
    readFloat(): number;
    readDouble(): number;
    readFixed(len: number): any[];
    readBytes(): Uint8Array;
    readString(): string;
    readEnum(): number;
    readArrayStart(): number;
    arrayNext(): number;
    readMapStart(): number;
    mapNext(): number;
    readArray(schema: any): any[];
    readDatum(schema: any): any;
}
export declare class BinaryWriter {
    constructor(schemas: any);
    buffer: Uint8Array;
    dataView: DataView;
    _index: number;
    schemas: {};
    getBuffer(): Buffer;
    getArrayBuffer(): any;
    alloc(size: number): void;
    realloc(size: number): void;
    require(bytes: any): void;
    encode(schema: any, datum: any): Uint8Array;
    writeByte(b: any): void;
    writeBoolean(value: any): void;
    writeInt(value: any): void;
    writeLong(value: any): void;
    writeFloat(f: any): void;
    writeDouble(value: any): void;
    writeBytes(bytes: Uint8Array): void;
    writeString(str: string): void;
    writeIndex(idx: any): void;
    writeMapStart(): void;
    writeMapEnd(): void;
    writeDatum(schema: any, datum: any): void;
}
export interface Schema {
    fullName: string;
    name: string;
    namespace: string;
}
export declare class SchemaCache {
    constructor(schemaArray: any[]);
    importSchemas(filePath: string): void;
    store(schema: any): void;
    validate(schema: any, datum: any): any;
}
